/* 

   Based on wif.c by D-oNe
   http://www.opensc.ws/c-c/2107-wireless-network-scanner.html
 
   BIG THANKS to GriYo of 29A for his article: 
   "Scanning for Wireless Networks" 
   In 29A Issue 8! 
 
   Feel free to use this code as you want as long as CREDITS are given! 

   Vista part based on
   http://www.hackclass.com/index.php?showtopic=97&pid=97&st=0&#entry97
   "released under the license of:if you use my code,give me credit."

   NDIS_WLAN_BSSID -> NDIS_WLAN_BSSID_EX patch and assemble it all together by unxed
 
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <winsock2.h>

/* XP part defines */

#define METHOD_OUT_DIRECT 2
#define FILE_ANY_ACCESS 0
#define FILE_DEVICE_PHYSICAL_NETCARD  0x0017

#define CTL_CODE(devicetype, function, method, access) (\
  ((devicetype)<<16) | ((access)<<14) | ((function)<<2) | (method))

#define NUMBEROFSSIDS 20

#define _NDIS_CONTROL_CODE(request, method) \
CTL_CODE(FILE_DEVICE_PHYSICAL_NETCARD, request, method, FILE_ANY_ACCESS)
#define IOCTL_NDIS_QUERY_GLOBAL_STATS _NDIS_CONTROL_CODE(0, METHOD_OUT_DIRECT)
#define OID_802_11_BSSID 0x0D010101
#define OID_802_11_SSID 0x0D010102
#define OID_802_11_NETWORK_TYPES_SUPPORTED 0x0D010203
#define OID_802_11_NETWORK_TYPE_IN_USE 0x0D010204
#define OID_802_11_TX_POWER_LEVEL 0x0D010205
#define OID_802_11_RSSI 0x0D010206
#define OID_802_11_RSSI_TRIGGER 0x0D010207
#define OID_802_11_INFRASTRUCTURE_MODE 0x0D010108
#define OID_802_11_FRAGMENTATION_THRESHOLD 0x0D010209
#define OID_802_11_RTS_THRESHOLD 0x0D01020A
#define OID_802_11_NUMBER_OF_ANTENNAS 0x0D01020B
#define OID_802_11_RX_ANTENNA_SELECTED 0x0D01020C
#define OID_802_11_TX_ANTENNA_SELECTED 0x0D01020D
#define OID_802_11_SUPPORTED_RATES 0x0D01020E
#define OID_802_11_DESIRED_RATES 0x0D010210
#define OID_802_11_CONFIGURATION 0x0D010211
#define OID_802_11_STATISTICS 0x0D020212
#define OID_802_11_ADD_WEP 0x0D010113
#define OID_802_11_REMOVE_WEP 0x0D010114
#define OID_802_11_DISASSOCIATE 0x0D010115
#define OID_802_11_POWER_MODE 0x0D010216
#define OID_802_11_BSSID_LIST 0x0D010217
#define OID_802_11_AUTHENTICATION_MODE 0x0D010118
#define OID_802_11_PRIVACY_FILTER 0x0D010119
#define OID_802_11_BSSID_LIST_SCAN 0x0D01011A
#define OID_802_11_WEP_STATUS 0x0D01011B
#define OID_802_11_RELOAD_DEFAULTS 0x0D01011C
typedef enum _NDIS_802_11_NETWORK_TYPE {
    Ndis802_11FH,
    Ndis802_11DS,
    Ndis802_11NetworkTypeMax
} NDIS_802_11_NETWORK_TYPE, *PNDIS_802_11_NETWORK_TYPE;

typedef LONG NDIS_802_11_RSSI;

typedef struct _NDIS_802_11_CONFIGURATION_FH {
    ULONG Length;
    ULONG HopPattern;
    ULONG HopSet;
    ULONG DwellTime;
} NDIS_802_11_CONFIGURATION_FH, *PNDIS_802_11_CONFIGURATION_FH;

typedef struct _NDIS_802_11_CONFIGURATION {
    ULONG Length;
    ULONG BeaconPeriod;
    ULONG ATIMWindow;
    ULONG DSConfig;
    NDIS_802_11_CONFIGURATION_FH FHConfig;
} NDIS_802_11_CONFIGURATION, *PNDIS_802_11_CONFIGURATION;

typedef enum _NDIS_802_11_NETWORK_INFRASTRUCTURE {
    Ndis802_11IBSS,
    Ndis802_11Infrastructure,
    Ndis802_11AutoUnknown,
    Ndis802_11InfrastructureMax
} NDIS_802_11_NETWORK_INFRASTRUCTURE, *PNDIS_802_11_NETWORK_INFRASTRUCTURE;

typedef enum _NDIS_802_11_AUTHENTICATION_MODE {
    Ndis802_11AuthModeOpen,
    Ndis802_11AuthModeShared,
    Ndis802_11AuthModeAutoSwitch,
    Ndis802_11AuthModeMax
} NDIS_802_11_AUTHENTICATION_MODE, *PNDIS_802_11_AUTHENTICATION_MODE;

typedef UCHAR NDIS_802_11_RATES[8];

typedef UCHAR NDIS_802_11_MAC_ADDRESS[6];

typedef struct _NDIS_802_11_SSID {
    ULONG SsidLength;
    UCHAR Ssid[32];
} NDIS_802_11_SSID, *PNDIS_802_11_SSID;

#define NDIS_802_11_LENGTH_RATES_EX     16
typedef UCHAR NDIS_802_11_RATES_EX[NDIS_802_11_LENGTH_RATES_EX];	// Set of 16 data rates

typedef struct _NDIS_WLAN_BSSID_EX {
    ULONG Length;
    NDIS_802_11_MAC_ADDRESS MacAddress;
    UCHAR Reserved[2];
    NDIS_802_11_SSID Ssid;
    ULONG Privacy;
    NDIS_802_11_RSSI Rssi;
    NDIS_802_11_NETWORK_TYPE NetworkTypeInUse;
    NDIS_802_11_CONFIGURATION Configuration;
    NDIS_802_11_NETWORK_INFRASTRUCTURE InfrastructureMode;
    NDIS_802_11_RATES_EX SupportedRates;
    ULONG IELength;
    UCHAR IEs[1];
} NDIS_WLAN_BSSID_EX, *PNDIS_WLAN_BSSID_EX;

typedef struct _NDIS_802_11_BSSID_LIST_EX {
    ULONG NumberOfItems;
    NDIS_WLAN_BSSID_EX Bssid[1];
} NDIS_802_11_BSSID_LIST_EX, *PNDIS_802_11_BSSID_LIST_EX;

/* Vista part defines */

#define DOT11_SSID_MAX_LENGTH 32
#define WLAN_MAX_NAME_LENGTH 256
#define WLAN_MAX_PHY_TYPE_NUMBER 8

#define WLAN_AVAILABLE_NETWORK_CONNECTED 0x00000001
#define WLAN_READ_ACCESS ( STANDARD_RIGHTS_READ | FILE_READ_DATA )
#define DOT11_RATE_SET_MAX_LENGTH 126

typedef ULONG WLAN_SIGNAL_QUALITY;
typedef UCHAR DOT11_MAC_ADDRESS[6];
typedef DOT11_MAC_ADDRESS *PDOT11_MAC_ADDRESS;

typedef enum _WLAN_INTERFACE_STATE {
    wlan_interface_state_connected = 1,
    wlan_interface_state_disconnected = 4,
    wlan_interface_state_authenticating = 7
} WLAN_INTERFACE_STATE, *PWLAN_INTERFACE_STATE;
typedef struct _WLAN_INTERFACE_INFO {
    GUID InterfaceGuid;
    WCHAR strInterfaceDescription[256];
    WLAN_INTERFACE_STATE isState;
} WLAN_INTERFACE_INFO, *PWLAN_INTERFACE_INFO;
typedef struct _WLAN_INTERFACE_INFO_LIST {
    DWORD dwNumberOfItems;
    DWORD dwIndex;
    WLAN_INTERFACE_INFO InterfaceInfo[];
} WLAN_INTERFACE_INFO_LIST, *PWLAN_INTERFACE_INFO_LIST;
typedef struct {
    LPWSTR wszGuid;
} INTF_KEY_ENTRY, *PINTF_KEY_ENTRY;
typedef struct {
    DWORD dwNumIntfs;
    PINTF_KEY_ENTRY pIntfs;
} INTFS_KEY_TABLE, *PINTFS_KEY_TABLE;
typedef struct _WLAN_NOTIFICATION_DATA {
    DWORD NotificationSource;
    DWORD NotificationCode;
    GUID InterfaceGuid;
    DWORD dwDataSize;
    PVOID pData;
} WLAN_NOTIFICATION_DATA, *PWLAN_NOTIFICATION_DATA;
typedef struct _WLAN_RATE_SET {
    ULONG uRateSetLength;
    USHORT usRateSet[DOT11_RATE_SET_MAX_LENGTH];
} WLAN_RATE_SET, *PWLAN_RATE_SET;
typedef struct _DOT11_SSID {
    ULONG uSSIDLength;
    UCHAR ucSSID[DOT11_SSID_MAX_LENGTH];
} DOT11_SSID, *PDOT11_SSID;
typedef enum _DOT11_BSS_TYPE {
    dot11_BSS_type_infrastructure,
    dot11_BSS_type_independent,
    dot11_BSS_type_any
} DOT11_BSS_TYPE, *PDOT11_BSS_TYPE;
typedef enum _DOT11_PHY_TYPE {
    dot11_phy_type_unknown,
    dot11_phy_type_any,
    dot11_phy_type_fhss,
    dot11_phy_type_dsss,
    dot11_phy_type_irbaseband,
    dot11_phy_type_ofdm,
    dot11_phy_type_hrdsss,
    dot11_phy_type_erp,
    dot11_phy_type_ht,
    dot11_phy_type_IHV_start,
    dot11_phy_type_IHV_end
} DOT11_PHY_TYPE, *PDOT11_PHY_TYPE;
typedef enum _DOT11_AUTH_ALGORITHM {
    DOT11_AUTH_ALGO_80211_OPEN = 1,
    DOT11_AUTH_ALGO_80211_SHARED_KEY = 2,
    DOT11_AUTH_ALGO_WPA = 3,
    DOT11_AUTH_ALGO_WPA_PSK = 4,
    DOT11_AUTH_ALGO_WPA_NONE = 5,
    DOT11_AUTH_ALGO_RSNA = 6,
    DOT11_AUTH_ALGO_RSNA_PSK = 7,
    DOT11_AUTH_ALGO_IHV_START = 0x80000000,
    DOT11_AUTH_ALGO_IHV_END = 0xffffffff
} DOT11_AUTH_ALGORITHM, *PDOT11_AUTH_ALGORITHM;
typedef enum _DOT11_CIPHER_ALGORITHM {
    DOT11_CIPHER_ALGO_NONE = 0x00,
    DOT11_CIPHER_ALGO_WEP40 = 0x01,
    DOT11_CIPHER_ALGO_TKIP = 0x02,
    DOT11_CIPHER_ALGO_CCMP = 0x04,
    DOT11_CIPHER_ALGO_WEP104 = 0x05,
    DOT11_CIPHER_ALGO_WPA_USE_GROUP = 0x100,
    DOT11_CIPHER_ALGO_RSN_USE_GROUP = 0x100,
    DOT11_CIPHER_ALGO_WEP = 0x101,
    DOT11_CIPHER_ALGO_IHV_START = 0x80000000,
    DOT11_CIPHER_ALGO_IHV_END = 0xffffffff
} DOT11_CIPHER_ALGORITHM, *PDOT11_CIPHER_ALGORITHM;

typedef DWORD WLAN_REASON_CODE, *PWLAN_REASON_CODE;
typedef struct _WLAN_BSS_ENTRY {
    DOT11_SSID dot11Ssid;
    ULONG uPhyId;
    DOT11_MAC_ADDRESS dot11Bssid;
    DOT11_BSS_TYPE dot11BssType;
    DOT11_PHY_TYPE dot11BssPhyType;
    LONG lRssi;
    ULONG uLinkQuality;
    BOOLEAN bInRegDomain;
    USHORT usBeaconPeriod;
    ULONGLONG ullTimestamp;
    ULONGLONG ullHostTimestamp;
    USHORT usCapabilityInformation;
    ULONG ulChCenterFrequency;
    WLAN_RATE_SET wlanRateSet;
    ULONG ulIeOffset;
    ULONG ulIeSize;
} WLAN_BSS_ENTRY, *PWLAN_BSS_ENTRY;
typedef struct _WLAN_BSS_LIST {
    DWORD dwTotalSize;
    DWORD dwNumberOfItems;
    WLAN_BSS_ENTRY wlanBssEntries[1];
} WLAN_BSS_LIST, *PWLAN_BSS_LIST;
typedef struct _WLAN_AVAILABLE_NETWORK {
    WCHAR strProfileName[WLAN_MAX_NAME_LENGTH];
    DOT11_SSID dot11Ssid;
    DOT11_BSS_TYPE dot11BssType;
    ULONG uNumberOfBssids;
    BOOL bNetworkConnectable;
    WLAN_REASON_CODE wlanNotConnectableReason;
    ULONG uNumberOfPhyTypes;
    DOT11_PHY_TYPE dot11PhyTypes[WLAN_MAX_PHY_TYPE_NUMBER];
// bMorePhyTypes is set to TRUE if the PHY types for the network
// exceeds WLAN_MAX_PHY_TYPE_NUMBER.
// In this case, uNumerOfPhyTypes is WLAN_MAX_PHY_TYPE_NUMBER and the
// first WLAN_MAX_PHY_TYPE_NUMBER PHY types are returned.
    BOOL bMorePhyTypes;
    WLAN_SIGNAL_QUALITY wlanSignalQuality;
    BOOL bSecurityEnabled;
    DOT11_AUTH_ALGORITHM dot11DefaultAuthAlgorithm;
    DOT11_CIPHER_ALGORITHM dot11DefaultCipherAlgorithm;
    DWORD dwFlags;
    DWORD dwReserved;
} WLAN_AVAILABLE_NETWORK, *PWLAN_AVAILABLE_NETWORK;
typedef struct _WLAN_RAW_DATA {
    DWORD dwDataSize;
    BYTE DataBlob[1];
} WLAN_RAW_DATA, *PWLAN_RAW_DATA;

typedef struct _WLAN_AVAILABLE_NETWORK_LIST {
    DWORD dwNumberOfItems;
    DWORD dwIndex;
    WLAN_AVAILABLE_NETWORK Network[1];
} WLAN_AVAILABLE_NETWORK_LIST, *PWLAN_AVAILABLE_NETWORK_LIST;

typedef enum _WLAN_OPCODE_VALUE_TYPE {
    wlan_opcode_value_type_query_only = 0,
    wlan_opcode_value_type_set_by_group_policy = 1,
    wlan_opcode_value_type_set_by_user = 2,
    wlan_opcode_value_type_invalid = 3
} WLAN_OPCODE_VALUE_TYPE, *PWLAN_OPCODE_VALUE_TYPE;

typedef enum _WLAN_INTF_OPCODE {
    wlan_intf_opcode_autoconf_start = 0x000000000,
    wlan_intf_opcode_autoconf_enabled,
    wlan_intf_opcode_background_scan_enabled,
    wlan_intf_opcode_media_streaming_mode,
    wlan_intf_opcode_radio_state,
    wlan_intf_opcode_bss_type,
    wlan_intf_opcode_interface_state,
    wlan_intf_opcode_current_connection,
    wlan_intf_opcode_channel_number,
    wlan_intf_opcode_supported_infrastructure_auth_cipher_pairs,
    wlan_intf_opcode_supported_adhoc_auth_cipher_pairs,
    wlan_intf_opcode_supported_country_or_region_string_list,
    wlan_intf_opcode_current_operation_mode,
    wlan_intf_opcode_supported_safe_mode,
    wlan_intf_opcode_certified_safe_mode,
    wlan_intf_opcode_autoconf_end = 0x0fffffff,
    wlan_intf_opcode_msm_start = 0x10000100,
    wlan_intf_opcode_statistics,
    wlan_intf_opcode_rssi,
    wlan_intf_opcode_msm_end = 0x1fffffff,
    wlan_intf_opcode_security_start = 0x20010000,
    wlan_intf_opcode_security_end = 0x2fffffff,
    wlan_intf_opcode_ihv_start = 0x30000000,
    wlan_intf_opcode_ihv_end = 0x3fffffff
} WLAN_INTF_OPCODE, *PWLAN_INTF_OPCODE;



DWORD(WINAPI * WlanOpenHandle) (DWORD, PVOID, PDWORD, PHANDLE);
DWORD(WINAPI * WlanEnumInterfaces) (HANDLE, PVOID, PWLAN_INTERFACE_INFO_LIST *);
VOID(WINAPI * WlanFreeMemory) (PVOID);
DWORD(WINAPI * WlanGetAvailableNetworkList) (HANDLE, const GUID *, DWORD, PVOID, PWLAN_AVAILABLE_NETWORK_LIST *);
DWORD(WINAPI * WlanScan) (HANDLE, const GUID *, const PDOT11_SSID, const PWLAN_RAW_DATA, PVOID);
DWORD(WINAPI * WlanCloseHandle) (HANDLE, PVOID);
DWORD(WINAPI * WlanGetProfile) (HANDLE, const GUID *, LPCWSTR, PVOID, LPWSTR *, DWORD *, PDWORD);
DWORD(WINAPI * WlanGetNetworkBssList) (HANDLE, const GUID *, const PDOT11_SSID, DOT11_BSS_TYPE, BOOL, PVOID, PWLAN_BSS_LIST *);
DWORD(WINAPI * WlanQueryInterface) (HANDLE, const GUID *, WLAN_INTF_OPCODE, PVOID, PDWORD, PVOID *, PWLAN_OPCODE_VALUE_TYPE);
DWORD(WINAPI * WlanReasonCodeToString) (DWORD, DWORD, PWCHAR, PVOID);

/* common defines */

typedef struct _ACCESS_POINT {
    LONG lRssi;
    DOT11_MAC_ADDRESS mac;
} ACCESS_POINT, *PACCESS_POINT;

typedef struct _ACCESS_POINTS_LIST {
    int size;
    ACCESS_POINT list[1];
} ACCESS_POINTS_LIST, *PACCESS_POINTS_LIST;

/* XP functions */

BOOL wif_adapterget(HKEY hKey, char *szPath, char *szKey, char *szBuffer, DWORD dwSize)
{
    HKEY rk = NULL;
    if (RegOpenKeyEx(hKey, szPath, 0, KEY_READ, &rk) != ERROR_SUCCESS)
	return FALSE;
    if (RegQueryValueEx(rk, szKey, NULL, NULL, (unsigned char *) szBuffer, &dwSize) != ERROR_SUCCESS)
	return FALSE;
    RegCloseKey(rk);
    return TRUE;
}

HANDLE wif_adapteropen(char *szAdapterName)
{
    HANDLE hAdapter;
    char szAdapter[MAX_PATH];
    _snprintf(szAdapter, sizeof(szAdapter) - 1, "\\\\.\\%s", szAdapterName);
    hAdapter = CreateFile(szAdapter, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
    return hAdapter;
}

PACCESS_POINTS_LIST wif_adapterlist()
{
    ACCESS_POINTS_LIST *ap_list;

    ap_list = (ACCESS_POINTS_LIST *) VirtualAlloc(NULL, sizeof(ACCESS_POINT) * NUMBEROFSSIDS + sizeof(int), MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
    int size = 0;

    BOOL bResult = 0;
    int macCnt;

    char szAdapter[128], szDescription[128], szKey[128], szServiceName[128];
    DWORD dwSize = 256;
    HKEY rk = NULL;
    int k = 0;
    HANDLE hAdapter;
    if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\NetworkCards", 0, KEY_READ, &rk) == ERROR_SUCCESS) {
	while (RegEnumKeyEx(rk, k, szKey, &dwSize, NULL, NULL, NULL, NULL) == ERROR_SUCCESS) {
	    _snprintf(szAdapter, sizeof(szAdapter) - 1, "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\NetworkCards\\%s", szKey);
	    wif_adapterget(HKEY_LOCAL_MACHINE, szAdapter, "Description", szDescription, sizeof(szDescription));
	    wif_adapterget(HKEY_LOCAL_MACHINE, szAdapter, "ServiceName", szServiceName, sizeof(szServiceName));

	    // printf("[+] %s - %s (%s)\n", szKey, szDescription, szServiceName); 

	    hAdapter = wif_adapteropen(szServiceName);


	    DWORD dwBytes, dwOIDCode;
	    int i1;
	    NDIS_802_11_BSSID_LIST_EX *pList;
	    pList = (NDIS_802_11_BSSID_LIST_EX *) VirtualAlloc(NULL, sizeof(NDIS_802_11_BSSID_LIST_EX) * NUMBEROFSSIDS, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
	    if (pList) {
		memset(pList, 0, sizeof(NDIS_802_11_BSSID_LIST_EX) * NUMBEROFSSIDS);
		dwOIDCode = OID_802_11_BSSID_LIST_SCAN;
		DeviceIoControl(hAdapter, IOCTL_NDIS_QUERY_GLOBAL_STATS, &dwOIDCode, sizeof(dwOIDCode), NULL, 0, &dwBytes, NULL);
		Sleep(2000);
		memset(pList, 0, sizeof(NDIS_802_11_BSSID_LIST_EX) * NUMBEROFSSIDS);
		dwOIDCode = OID_802_11_BSSID_LIST;
		if (DeviceIoControl(hAdapter, IOCTL_NDIS_QUERY_GLOBAL_STATS, &dwOIDCode, sizeof(dwOIDCode), pList, sizeof(NDIS_802_11_BSSID_LIST_EX) * NUMBEROFSSIDS, &dwBytes, NULL)) {

		    bResult = 1;

		    // printf("[+] Found %i network(s)!\n", pList->NumberOfItems); 

		    // references for this solution:
		    // http://www.tech-archive.net/Archive/Development/microsoft.public.development.device.drivers/2008-02/msg00643.html
		    // http://www.codeproject.com/KB/IP/wlanscan_ndis.aspx?display=Print

		    PNDIS_WLAN_BSSID_EX pBssid = (PNDIS_WLAN_BSSID_EX) & pList[0].Bssid;

		    for (i1 = 0; i1 < pList->NumberOfItems; ++i1) {

			ap_list->list[size].lRssi = pBssid->Rssi;
			for (macCnt = 0; macCnt < 6; macCnt++)
			{
			    ap_list->list[size].mac[macCnt] = pBssid->MacAddress[macCnt];
			}

			// Move To The Next BSSID List Element
			pBssid = (PNDIS_WLAN_BSSID_EX) ((char *) pBssid + pBssid->Length);

			size++;
		    }

		}

		VirtualFree(pList, 0, MEM_RELEASE);

	    }

	    dwSize = 256;
	    k++;
	}
	RegCloseKey(rk);
    }

    if (bResult == 0) {
	return 0;
    }

    ap_list->size = size;
    return ap_list;
}

/* Vista function */

PACCESS_POINTS_LIST list_wifi_vista()
{
    ACCESS_POINTS_LIST *ap_list;

    ap_list = (ACCESS_POINTS_LIST *) VirtualAlloc(NULL, sizeof(ACCESS_POINT) * NUMBEROFSSIDS + sizeof(int), MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
    int size = 0;

    int macCnt;

    BOOL bResult = 0;
    HMODULE hWinlib = LoadLibrary("Wlanapi.dll");
    if (hWinlib) {
	DWORD dwVers = 0, dummy;
	WlanOpenHandle = (DWORD(WINAPI *) (DWORD, PVOID, PDWORD, PHANDLE)) GetProcAddress(hWinlib, "WlanOpenHandle");
	WlanEnumInterfaces = (DWORD(WINAPI *) (HANDLE, PVOID, PWLAN_INTERFACE_INFO_LIST *)) GetProcAddress(hWinlib, "WlanEnumInterfaces");
	WlanFreeMemory = (VOID(WINAPI *) (PVOID)) GetProcAddress(hWinlib, "WlanFreeMemory");
	WlanGetAvailableNetworkList = (DWORD(WINAPI *) (HANDLE, const GUID *, DWORD, PVOID, PWLAN_AVAILABLE_NETWORK_LIST *)) GetProcAddress(hWinlib, "WlanGetAvailableNetworkList");
	WlanScan = (DWORD(WINAPI *) (HANDLE, const GUID *, const PDOT11_SSID, const PWLAN_RAW_DATA, PVOID)) GetProcAddress(hWinlib, "WlanScan");
	WlanCloseHandle = (DWORD(WINAPI *) (HANDLE, PVOID)) GetProcAddress(hWinlib, "WlanCloseHandle");
	WlanGetProfile = (DWORD(WINAPI *) (HANDLE, const GUID *, LPCWSTR, PVOID, LPWSTR *, DWORD *, PDWORD)) GetProcAddress(hWinlib, "WlanGetProfile");
	WlanGetNetworkBssList = (DWORD(WINAPI *) (HANDLE, const GUID *, const PDOT11_SSID, DOT11_BSS_TYPE, BOOL, PVOID, PWLAN_BSS_LIST *)) GetProcAddress(hWinlib, "WlanGetNetworkBssList");
	WlanQueryInterface = (DWORD(WINAPI *) (HANDLE, const GUID *, WLAN_INTF_OPCODE, PVOID, PDWORD, PVOID *, PWLAN_OPCODE_VALUE_TYPE)) GetProcAddress(hWinlib, "WlanQueryInterface");
	WlanReasonCodeToString = (DWORD(WINAPI *) (DWORD, DWORD, PWCHAR, PVOID)) GetProcAddress(hWinlib, "WlanReasonCodeToString");

	//Note unused functions are here because they were removed due to being untested

	if (WlanQueryInterface == 0 || WlanReasonCodeToString == 0 || WlanGetNetworkBssList == 0 || WlanGetProfile == 0 || WlanCloseHandle == 0 || WlanScan == 0 || WlanGetAvailableNetworkList == 0 || WlanFreeMemory == 0 || WlanOpenHandle == 0 || WlanEnumInterfaces == 0) {
	    // printf("\r\n\r\nOne of the functions did not load correctly\r\n");
	    FreeLibrary(hWinlib);
	    return 0;
	}

	HANDLE hHandle = INVALID_HANDLE_VALUE;

	PWLAN_INTERFACE_INFO_LIST list = { 0 };
	PWLAN_AVAILABLE_NETWORK_LIST w = { 0 };
	char szBuffer[16 * 1024], szName[WLAN_MAX_NAME_LENGTH + 5];
	LPWSTR xmlinfo = L"";
	DWORD d = WLAN_READ_ACCESS;

	PWLAN_BSS_LIST bl = { 0 };

	if (WlanOpenHandle(1, 0, &dwVers, &hHandle) == ERROR_SUCCESS) {
	    if (WlanEnumInterfaces(hHandle, 0, &list) == ERROR_SUCCESS) {
		if (WlanScan(hHandle, &list->InterfaceInfo[0].InterfaceGuid, 0, 0, 0) == ERROR_SUCCESS) {
		    // vista only

		    Sleep(2000);	// wait until scan completes

		    if (WlanGetNetworkBssList(hHandle, &list->InterfaceInfo[0].InterfaceGuid, NULL, 0, 0, NULL, &bl) == ERROR_SUCCESS) {
			bResult = 1;

			// PWLAN_BSS_ENTRY pBssid = (PWLAN_BSS_ENTRY )&bl->wlanBssEntries[0];

			// printf("<count>%d</count>", bl->dwNumberOfItems);

			for (dummy = 0; dummy < bl->dwNumberOfItems; dummy++) {

			    ap_list->list[size].lRssi = bl->wlanBssEntries[dummy].lRssi;
			    for (macCnt = 0; macCnt < 6; macCnt++)
			    {
			        ap_list->list[size].mac[macCnt] = bl->wlanBssEntries[dummy].dot11Bssid[macCnt];
			    }
			    size++;

			}
		    } else {
			// printf("\r\n\r\nFatal - WlanGetNetworkBssList() failed with error code %ld (are we under XP?)\r\n", GetLastError());
		    }

		    WlanFreeMemory(&list);

		} else {
		    // printf("\r\n\r\nFatal - WlanScan() failed with error code %d\r\n", (int) GetLastError());
		}
	    } else
		// printf("\r\n\r\nFatal - WlanEnumInterfaces() failed with error code %ld\r\n", GetLastError());
		WlanCloseHandle(hHandle, 0);
	} else
	    // printf("\r\n\r\nFatal - WlanOpenHandle unssuccessful with error code %d\r\nMake sure the Current Windows Version supports Wifi API\r\n", (int) GetLastError());
	    CloseHandle(hHandle);
	FreeLibrary(hWinlib);
    } else
	// printf("\r\n\r\nUnable to load module\r\n");

    if (bResult == 0) {
	return 0;
    }

    ap_list->size = size;
    return ap_list;
}

/* main */
 
int main(int argc, char *argv[]) 
{ 
    char szAdapter[128], szDescription[128], szServiceName[128]; 
    HANDLE hAdapter; 

    printf("wifilist v. 1.0.1a\n");

    DWORD dwVersion = 0;
    DWORD dwMajorVersion = 0;

    /* Get the Windows version. */
    dwVersion = GetVersion();
    dwMajorVersion = (DWORD)(LOBYTE(LOWORD(dwVersion)));

    PACCESS_POINTS_LIST list;

    /* If the version is older than vista */
    if (dwMajorVersion < 6) {
	list = wif_adapterlist();
    } else {
	list = list_wifi_vista();
    }

    if (list == 0) {
	printf("no networks found\n");
	return;
    }

    printf("scan complete, found %i network(s)\n", list->size);

    int cnt;
    for (cnt = 0; cnt < list->size; cnt++) {
	printf("%02X:%02X:%02X:%02X:%02X:%02X %i\n",
		list->list[cnt].mac[0], 
		list->list[cnt].mac[1], 
		list->list[cnt].mac[2], 
		list->list[cnt].mac[3], 
		list->list[cnt].mac[4],
		list->list[cnt].mac[5],
		list->list[cnt].lRssi);
    }

    VirtualFree(list, 0, MEM_RELEASE);

    return 0; 
}
